package info.aspirecn.iov.sjjh.supplier10000027.service;

import info.aspirecn.iov.sjjh.commons.lang.ChannelTypeHandleResponseObject;
import info.aspirecn.iov.sjjh.supplier10000027.vo.ApplyResponseObject;

import javax.servlet.http.HttpServletRequest;

public interface ChannelService {
    /**
     * 验签
     * @param authMode
     * @param outTime
     * @param
     */
    ApplyResponseObject dataSignature(String authMode, int outTime);

    /**
     * 复合信息
     * 对提供的姓名、公民身份号码、有效期起始日期、有效期截止日期四项信息作为认证申请保留数据进行验证；
     * @param request
     * @param customBody
     * @param outTime
     * @return
     */
    ChannelTypeHandleResponseObject validateCompositeIdentityInfo(HttpServletRequest request, String customBody, int outTime);

    /**
     * 简项信息
     * 对提供的姓名、身份证号两项信息作为认证申请保留数据进行验证；
     * @param request
     * @param customBody
     * @param outTime
     * @return
     */
    ChannelTypeHandleResponseObject validateIdentityInfo(HttpServletRequest request, String customBody, int outTime);

    /**
     * 人像+简项信息
     * @param request
     * @param customBody
     * @param outTime
     * @return
     */
    ChannelTypeHandleResponseObject validatePhotoIdentityInfo(HttpServletRequest request, String customBody, int outTime);

    /**
     * 简项信息
     * 对提供的姓名、身份证号两项信息作为认证申请保留数据进行验证；
     * 中心-通用版
     * @param request
     * @param customBody
     * @param outTime
     * @return
     */
    ChannelTypeHandleResponseObject validateIdentityInfoCommon(HttpServletRequest request, String customBody, int outTime, String decodeType);

    /**
     * 身份证有效性核验
     * @param request
     * @param customBody
     * @param outTime
     * @return
     */
    ChannelTypeHandleResponseObject validateIdentityInfoValidity(HttpServletRequest request, String customBody, int outTime);

}
